package com.malk.minjiaoyuan.controller;

import com.alibaba.fastjson.JSON;
import com.malk.Util.UtilMap;
import com.malk.minjiaoyuan.service.MJYService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDR_New;
import com.malk.service.aliwork.YDClient;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Contacts;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 错误抛出与拦截详见CatchException
 */
@Slf4j
@RestController
@RequestMapping("/minjiaoyuan")
public class InviteControl {


    @Autowired
    private YDClient ydClient;

    @Autowired
    private DDClient ddClient;

    @Autowired
    private DDClient_Contacts ddClient_contacts;

    @Autowired
    private MJYService mjyService;

    /**
     * 同步学校 & 钉钉通讯录
     */
    @SneakyThrows
    @PostMapping("sync/department")
    McR department() {
        log.info("同步学校 & 钉钉通讯录");
        List<Map> deptList = ddClient_contacts.getDepartmentDetail_all(ddClient.getAccessToken());
        for (Map dept : deptList) {
            YDParam ydParam = YDParam.builder()
                    .formUuid("FORM-AC666081555ANZAZ6D4IVCQLY5Y12P4ZSRTGLUE")
                    .searchFieldJson(JSON.toJSONString(UtilMap.map("selectField_lgf41nj4", dept.get("name"))))
                    .pageSize(1)
                    .build();
            DDR_New ddr_new = ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_search_form);
            if (ddr_new.getTotalCount() == 0) {
                continue;
            }
            Map formData = ((List<Map>) ddr_new.getData()).get(0);
            if (StringUtils.isNotBlank(String.valueOf(((Map) formData.get("formData")).get("textField_lhldcchn")))) {
                continue;
            }
            Thread.sleep(100); // 避免限流
            ydParam.setFormInstanceId(formData.get("formInstanceId").toString());
            ydParam.setUpdateFormDataJson(JSON.toJSONString(UtilMap.map("textField_lhldcchn", dept.get("dept_id"))));
            ydClient.operateData(ydParam, YDConf.FORM_OPERATION.update);
        }
        return McR.success();
    }

    /**
     * 创建人员: 邀请到架构 [配置提交校验, 无需更新宜搭单据]
     */
    @PostMapping("invite/user")
    McR createUser(@RequestBody Map data) {
        log.info("创建员工, {}", data);
        McException.assertParamException_Null(data, "userId", "name", "mobile", "deptId");
        Map bodyInfo = UtilMap.map("userid", data.get("userId"));
        ddClient_contacts.createUser(ddClient.getAccessToken(), String.valueOf(data.get("name")), String.valueOf(data.get("mobile")), Arrays.asList(String.valueOf(data.get("deptId"))), bodyInfo);
        return McR.success();
    }

    /**
     * 同步教师档案 [已邀请], 定时同步后更新为已同步
     */
    @PostMapping("sync/teacher")
    McR syncTeacherStatus() {
        mjyService.syncTeacherStatus();
        return McR.success();
    }
}
