package com.malk.minjiaoyuan.schedule;

import com.malk.minjiaoyuan.service.MJYService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

/**
 * @EnableScheduling 开启桑诺定时任务 [配置参考McScheduleTask]
 */
@Slf4j
@Configuration
@EnableScheduling
@ConditionalOnProperty(name = {"spel.scheduling"})
public class MJYScheduleTask {

    @Autowired
    private MJYService mjyService;

    /**
     * 定时同步后更新为已同步 [0...5分钟/次]
     */
    @Scheduled(cron = "0 0/5 * * * ?")
    public void Time_Period_1() {
        try {
            log.info("###### [MJY]同步教师档案开始 [已邀请] ######");
            mjyService.syncTeacherStatus();
        } catch (Exception e) {
            log.error(e.getMessage(), e); // 记录错误日志
        }
        log.info("###### [MJY]同步教师档案结束 [已邀请] ######");
    }
}