package com.malk.rongzhi.controller;

import com.malk.Util.UtilDateTime;
import com.malk.rongzhi.server.RZConf;
import com.malk.rongzhi.service.RZService;
import com.malk.server.common.McR;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDateTime;
import java.util.Map;

/**
 * 错误抛出与拦截详见CatchException
 */
@Slf4j
@RestController
@RequestMapping("/rongzhi")
public class RongZhiController {

    @Autowired
    private RZService rzService;

    /**
     * 钉钉考勤同步
     */
    @PostMapping("/attendance")
    McR attendance(@RequestBody Map<String, String> param) {
        rzService.uploadTravelData();
        return McR.success();
    }

    /**
     * 推送易快报
     */
    @PostMapping("/form-push")
    McR formPush(@RequestBody Map<String, String> param) {
        return McR.success(rzService.getAccessToken(RZConf.TYPE.ekuaibao));
    }

    @PostMapping("/test")
    McR test() {
        LocalDateTime finish = UtilDateTime.getLocalDateTimeFromTimestamp(1685461901000L + 1 * 60 * 60 * 1000L);
        log.info("xxx, {}", finish);
        return McR.success(finish.getHour());
    }
}
