package com.malk.shanghaishiwei.server;

import cn.hutool.core.util.ObjectUtil;
import com.malk.Util.UtilHttp;
import com.malk.server.common.McException;
import com.malk.server.common.VenR;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Map;

/**
 * 返回值配置参考McR
 */
@Data
@NoArgsConstructor
public class HTR extends VenR {

    private boolean isSuccess;

    private String errorCode;

    private String errorMessage;

    private String data;

    /**
     * 断言错误信息
     */
    @Override
    public void assertSuccess() {
        McException.assertException(ObjectUtil.isNotNull(errorCode) || !isSuccess, errorCode, errorMessage, "SHHT");
    }

    /**
     * 通用post请求
     */
    public static HTR doPost(String url, Map header, Map param, Map body) {
        return (HTR) UtilHttp.doPost(url, header, param, body, HTR.class);
    }

    /**
     * 通用get请求
     */
    public static HTR doGet(String url, Map header, Map param) {
        return (HTR) UtilHttp.doGet(url, header, param, HTR.class);
    }
}

