package com.malk.shanghaishiwei.service;

import java.util.List;
import java.util.Map;

public interface HTClient {

    /**
     * 获取采购合同类型列表
     */
    List<Map> listContractType();

    /**
     * 添加采购合同
     */
    boolean addPurchaseContact(Map body);

    /**
     * 删除采购合同合同信息
     */
    boolean deletePurchaseContract(String origionContractcode);

    /**
     * 添加采购合同条款信息
     */
    boolean addTermsContract(Map body);

    /**
     * 删除采购合同条款信息
     *
     * @param agreementType 对方押金质保金 = 1, 暂缓支付质保金 = 2, 普通条款 = 3
     */
    boolean deleteTermsContract(String origionContractCode, String datetime, int agreementType);

    /**
     * 添加采购合同附件信息
     */
    boolean addAttachmentContract(Map body);

    /**
     * 删除采购合同附件 [合同类型 1采购合同，2销售合同] - 默认采购合同
     */
    boolean deleteAttachmentContract(String origionContractCode, String fileType, String fileName);
}
