package com.malk.xiding.controller;

import com.alibaba.fastjson.JSON;
import com.malk.Util.UtilDateTime;
import com.malk.server.common.McR;
import com.malk.server.fxiaoke.FXKConf;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Attendance;
import com.malk.service.fxiaoke.FXKClient;
import com.malk.xiding.repository.dao.XdDdApproveRecordDao2;
import com.malk.xiding.repository.dao.XdDdFxkRelationDao;
import com.malk.xiding.repository.entity.XdFxkDdAttendancePo;
import com.malk.xiding.server.XDConf;
import com.malk.xiding.service.XDService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 错误抛出与拦截详见CatchException
 */
@Slf4j
@RestController
@RequestMapping("/xiding")
public class XDController {

    @Autowired
    private XDService xdService;

    @Autowired
    private DDClient_Attendance ddClient_attendance;

    @Autowired
    private DDClient ddClient;

    @Autowired
    private XdDdApproveRecordDao2 approveRecordDao2;

    @Autowired
    private FXKClient fxkClient;

    @Autowired
    private FXKConf fxkConf;

    @Autowired
    private XdDdFxkRelationDao relationDao;


    @PostMapping("test3")
    McR test3(@RequestParam String name) {
        Date sTime = UtilDateTime.parseDateTime("2023-05-04" + " 00:00:00");
        Date eTime = UtilDateTime.parseDateTime("2023-05-31" + " 23:59:59");

        List<Map> records = fxkClient.getAttendance_All(fxkClient.getAccessToken(), fxkConf.getCorpId(), sTime.getTime(), eTime.getTime(), Arrays.asList(relationDao.findByName(name).getIdFxxk()));
//        log.info("xxxx, {}", records.size());
//
//        Date tTime = UtilDateTime.parseDateTime("2023-05-04" + " 04:11:00");
//
//        // 时区测试 @Temporal & @JsonFormat
//        Date check = UtilDateTime.parseDateTime(UtilDateTime.formatDate(new Date(tTime.getTime() - (tTime.getHours() + 1) * 60 * 60 * 1000)) + " 18:00:00");
//        log.error("xxxx, {}", JSON.parseObject(JSON.toJSONString(records.get(0)), XdFxkDdAttendancePo.class));
//
//        log.info("xxxx, {}, {}", check, UtilDateTime.formatDateTime(new Date(tTime.getTime() - (tTime.getHours() + 1) * 60 * 60 * 1000)));
        return McR.success(JSON.parseArray(JSON.toJSONString(records), XdFxkDdAttendancePo.class));
//        return McR.success(JSON.parseObject(JSON.toJSONString(records.get(0)), XdFxkDdAttendancePo.class));
    }

    @PostMapping("test1")
    McR test1() {
        Date eTime = UtilDateTime.parseDateTime(UtilDateTime.formatDate(new Date()) + " 23:59:59");
        Date sTime = UtilDateTime.parseDateTime(UtilDateTime.formatDate(new Date()) + " 11:00:00");

        String Time = UtilDateTime.formatLocalDate(UtilDateTime.convertToLocalDateTimeFromDate(sTime).plusDays(1).toLocalDate()) + " 05:00:00";

        log.info("xxxx, {}, {}", sTime, Time);
//        ddClient_attendance.listAttendanceRecord(ddClient.getAccessToken(), Arrays.asList("1007515542693640"), "2023-05-17 00:00:00", "2023-05-24 23:59:59");

//        return McR.success(ddClient_attendance.uploadAttendanceRecord(ddClient.getAccessToken(), "1111", "纷享销客同步", "纷享销客同步", null, new Date().getTime()));
//        return McR.success(approveRecordDao2.findAllByEndTimeAfter(UtilDateTime.parseDateTime("2023-05-18 00:00:00"), PageRequest.of(0, 50)));
        return McR.success();
    }

    @PostMapping("test")
    McR test() {
        long startTime = UtilDateTime.parseDateTime("2023-05-01" + " 00:00:00").getTime();
        long endTime = UtilDateTime.parseDateTime("2023-05-31" + " 23:59:59").getTime();
        xdService.syncApprove(startTime, endTime, XDConf.TMP_CODE_CC, "出差");
        xdService.syncApprove(startTime, endTime, XDConf.TMP_CODE_WC, "外出");
        return McR.success();
    }

    @PostMapping("test2")
    McR test2() {
        Date eTime = UtilDateTime.parseDateTime("2023-05-31" + " 23:59:59");
        Date sTime = UtilDateTime.parseDateTime("2023-05-04" + " 00:00:00");
        xdService.syncAttendance(0, sTime, eTime);
        return McR.success();
    }
}
