package com.malk.xiding.repository.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.malk.base.BasePo;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import java.util.Date;


@Entity
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "xd_dd_approve_record")
public class XdDdApproveRecordPo extends BasePo {

    /**
     * 钉钉用户ID
     */
    private String userId;

    /**
     * 纷享销客ID
     */
    private String openUserId;

    /**
     * 员工姓名
     */
    private String userName;

    /**
     * 实例id
     */
    private String instanceId;

    /**
     * 开始日期
     */
    @Temporal(TemporalType.TIMESTAMP)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date startTime;

    /**
     * 结束日期
     */
    @Temporal(TemporalType.TIMESTAMP)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date endTime;

    /**
     * 类型: 出差\外出
     */
    private String type;
}
