package com.malk.xiding.repository.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.malk.base.BasePo;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.Date;

@Entity
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "xd_fxk_dd_attendance")
public class XdFxkDdAttendancePo extends BasePo {

    /**
     * 钉钉ID
     */
    private String idDd;

    /**
     * 员工姓名
     */
    @Column(name = "name")
    private String userName;

    /**
     * 纷享销客ID
     */
    @Column(name = "idFxxk")
    private String openUserId;

    /**
     * 外勤时间 [fixme: 指定时区, new Date 会默认当前系统时区, 不添加 json 时区注解, 会出现序列化后的对象时间不是 GMT 时区]
     */
    @Temporal(TemporalType.TIMESTAMP)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date checkTime;

    /**
     * 外勤地址
     */
    private String checkAddress;

    /**
     * 同步备注
     */
    private String remark;

    /**
     * 外勤备注
     */
    private String outside;
}
