package com.malk.xintianlong.repository.dao;

import com.malk.xintianlong.repository.entity.HSApproveRecordPo;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import javax.transaction.Transactional;
import java.util.List;

@Transactional
public interface HSApproveRecordDao extends JpaRepository<HSApproveRecordPo, Long> {

    @Query(value = "update HSApproveRecordPo set approveResult = ?2, hsResponse = ?3 where processInstanceId = ?1")
    @Modifying
    void updateApproveResult(String processInstanceId, String approveResult, String hsResponse);

    HSApproveRecordPo findByProcessInstanceId(String processInstanceId);

    List<HSApproveRecordPo> findAllByApproveResult(String approveResult);

    List<HSApproveRecordPo> findAllByOrderCodeIn(List<String> orderCodeList);

    HSApproveRecordPo findByOrderCodeAndApproveResultAndCorpType(String orderCode, String approveResult, String corpType);
}
