package com.malk.xintianlong.repository.entity;

import com.malk.base.BasePo;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Entity;
import javax.persistence.Table;

@Entity
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "hs_approve_record")
public class HSApproveRecordPo extends BasePo {

    /**
     * 公司主体。⾦塔克斯：01，灝景： 02
     */
    private String corpType;

    /**
     * 申请单据编号
     */
    private String orderCode;

    /**
     * 申请⼈编号【钉钉 userId】
     */
    private String proposerCode;

    /**
     * 钉钉审批记录ID
     */
    private String processInstanceId;

    /**
     * 审批结果。agree：同意，refuse：拒绝， process：流程中, terminated: 已撤销
     */
    @Builder.Default
    private String approveResult = "process";

    /**
     * 备注信息
     */
    private String remark;

    /**
     * 回调环思单据类型。SD001: 指定书, PU001 申购单, 结算单 TS001
     */
    private String formType;

    /**
     * 环思回调结果
     */
    private String hsResponse;
}
