package com.malk.service.tencent.impl;

import com.alibaba.fastjson.JSON;
import com.malk.server.tencent.TXYConf;
import com.malk.service.tencent.TXYInvoice;
import com.tencentcloudapi.common.Credential;
import com.tencentcloudapi.common.profile.ClientProfile;
import com.tencentcloudapi.common.profile.HttpProfile;
import com.tencentcloudapi.ocr.v20181119.OcrClient;
import com.tencentcloudapi.ocr.v20181119.models.MixedInvoiceOCRRequest;
import com.tencentcloudapi.ocr.v20181119.models.MixedInvoiceOCRResponse;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

@Slf4j
@Service
public class TXYImplInvoice implements TXYInvoice {

    @Autowired
    private TXYConf txyConf;

    // 创建请求描述
    private ClientProfile doRequest(String endPoint) {

        HttpProfile httpProfile = new HttpProfile();
        httpProfile.setEndpoint(endPoint);
        ClientProfile clientProfile = new ClientProfile();
        clientProfile.setHttpProfile(httpProfile);
        return clientProfile;
    }


    /**
     * 混贴票据识别
     */
    @SneakyThrows
    @Override
    public Map doMixedInvoiceOCR(String imageUrl) {

        Credential cred = new Credential(txyConf.getSecretId(), txyConf.getSecretKey());
        ClientProfile clientProfile = doRequest("ocr.tencentcloudapi.com");
        OcrClient client = new OcrClient(cred, txyConf.getRegion(), clientProfile);

        MixedInvoiceOCRRequest req = new MixedInvoiceOCRRequest();
        req.setImageUrl(imageUrl);
        MixedInvoiceOCRResponse resp = client.MixedInvoiceOCR(req);
        return (Map) JSON.parse(MixedInvoiceOCRResponse.toJsonString(resp));

//        try {
//
//        } catch (TencentCloudSDKException e) {
//            McException.assertException(false, "", e.getMessage(), "tencent-yun");
//            log.error(e.getMessage(), e);  // 记录错误日志
//        }
//        return null;
    }


}
